import java.io.*;
import java.util.*;

import javax.servlet.*;
import javax.servlet.http.*;

import org.apache.velocity.Template;
import org.apache.velocity.context.Context;
import org.apache.velocity.servlet.*;
import org.apache.velocity.runtime.*;

import org.apache.velocity.exception.ResourceNotFoundException;
import org.apache.velocity.exception.ParseErrorException;


public class SampleVelocity extends VelocityServlet
{
    private  Properties propExtra = new Properties();

    public void init(javax.servlet.ServletConfig config)
        throws javax.servlet.ServletException
    {
        super.init(config);

        String fileName      = "WEB-INF/conf/extralinks.properties";

        boolean propertyFileFound = false;
   
        try 
        {
            java.net.URL url = getServletContext().getResource(fileName);
            propExtra.load(url.openStream());
            propertyFileFound=true;
        }
        catch (IOException Ignored) 
        {
            Ignored.printStackTrace();
        }           
     
        if (!propertyFileFound)
        {
            log(" couldn't load extralinks.properties");
        }       
    }

    public Template handleRequest(Context ctx)
    {
        Vector linkList = getExtraLinks();

        ctx.put("theList", linkList);
        ctx.put("ast","[*]");

        Template outty = null;
        
        try
        {
            outty =  getTemplate("sample.vm");
        }
        catch(ParseErrorException pee)
        {
            System.out.println("SampleServlet : parse error for template " + pee);
        }
        catch(ResourceNotFoundException rnfe)
        {
            System.out.println("SampleServlet : template not found " + rnfe);
        }
        catch(Exception e)
        {
            System.out.println("Error " + e);
        }
        return outty;
    }

    protected Vector getExtraLinks()
    {
        Vector result    = new Vector();

        Enumeration e = propExtra.propertyNames();
        while(e.hasMoreElements()) 
        {
            String key = (String)e.nextElement();
            String val = propExtra.getProperty(key);
      
            if (!(val.indexOf(",")<0))
            {
         
                String des = val.substring(0,val.indexOf(","));
                String add = val.substring(val.indexOf(",")+1,val.length());
                if (!add.startsWith("http://"))
                {
                    add = "http://"+add.trim();
                }
      
                ExtraLink el = new ExtraLink(des,add);
                result.addElement(el);
            }
        }
        return result;
    }

	//=============================================================
	public class ExtraLink
	{
	    private String Description;
	    private String Address;
	    
	    public ExtraLink(String _description, String _address)
	    {
	         Description = _description;
	         Address     = _address;
	    }
	    public String getDescription()
	    {
	        return this.Description;
	    }
	    public String getAddress()
	    {
	        return this.Address;
	    }
	}
}
